#pragma semicolon 1
#include <sdktools>
#include <sdkhooks>
#include <vip_core>

public Plugin myinfo =
{
	name = "[VIP] Radar Invis",
	author = "Pheonix (˙·٠●Феникс●٠·˙)",
	version = "1.1",
	url = "zizt.ru"
};

#define VIP_RADAR_INVIS				"Radar-Invis"

int tut[MAXPLAYERS+1] = {INVALID_ENT_REFERENCE,...};

public void OnPluginStart()
{
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_team", Event_PlayerTeam);
}

public void OnClientPutInServer(iClient) 
{
	tut[iClient] = INVALID_ENT_REFERENCE;
}

public void OnMapStart() 
{
	PrecacheModel("models/rxg/smokevol.mdl");
	AddFileToDownloadsTable("materials/rxg/smokevol.vmt");
	AddFileToDownloadsTable("materials/rxg/smokevol.vtf");
	AddFileToDownloadsTable("models/rxg/smokevol.dx90.vtx");
	AddFileToDownloadsTable("models/rxg/smokevol.mdl");
	AddFileToDownloadsTable("models/rxg/smokevol.phy");
	AddFileToDownloadsTable("models/rxg/smokevol.vvd");
}

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_RADAR_INVIS, BOOL, TOGGLABLE, ToggleItemCallback, OnDisplayItem);
}

public Action Event_PlayerSpawn(Event event, const char[] name, bool dontBroadcast)
{
	int iClient = GetClientOfUserId(event.GetInt("userid"));
	if(VIP_IsClientVIP(iClient) && VIP_IsClientFeatureUse(iClient, VIP_RADAR_INVIS))
	{
		int iEnt = EntRefToEntIndex(tut[iClient]);
		if(iEnt != INVALID_ENT_REFERENCE) AcceptEntityInput(iEnt, "Kill");
		float pos[3];
		GetEntPropVector(iClient, Prop_Data, "m_vecOrigin", pos);
		iEnt = CreateEntityByName("prop_physics_multiplayer");
		SetEntityModel(iEnt, "models/rxg/smokevol.mdl");	
		TeleportEntity(iEnt, pos, NULL_VECTOR, NULL_VECTOR);
		DispatchSpawn(iEnt);
		SetEntityMoveType(iEnt, MOVETYPE_NONE);
		AcceptEntityInput(iEnt, "DisableMotion");
		SDKHook(iEnt, SDKHook_ShouldCollide, OnCollision); 
		SetVariantString("!activator");
		AcceptEntityInput(iEnt, "SetParent", iClient, iEnt);
		SetEdictFlags(iEnt, (GetEdictFlags(iEnt)&(~FL_EDICT_ALWAYS))|FL_EDICT_DONTSEND);
		tut[iClient] = EntIndexToEntRef(iEnt);
	}
}
	
public Action ToggleItemCallback(int iClient, const char[] sFeatureName, VIP_ToggleState OldStatus, VIP_ToggleState &Status)
{
	int iEnt = EntRefToEntIndex(tut[iClient]);
	if(iEnt != INVALID_ENT_REFERENCE) AcceptEntityInput(iEnt, "Kill");
	if(Status == ENABLED)
	{
		float pos[3];
		GetEntPropVector(iClient, Prop_Data, "m_vecOrigin", pos);
		iEnt = CreateEntityByName("prop_physics_multiplayer");
		SetEntityModel(iEnt, "models/rxg/smokevol.mdl");	
		TeleportEntity(iEnt, pos, NULL_VECTOR, NULL_VECTOR);
		DispatchSpawn(iEnt);
		SetEntityMoveType(iEnt, MOVETYPE_NONE);
		AcceptEntityInput(iEnt, "DisableMotion");
		SDKHook(iEnt, SDKHook_ShouldCollide, OnCollision); 
		SetVariantString("!activator");
		AcceptEntityInput(iEnt, "SetParent", iClient, iEnt);
		SetEdictFlags(iEnt, (GetEdictFlags(iEnt)&(~FL_EDICT_ALWAYS))|FL_EDICT_DONTSEND);
		tut[iClient] = EntIndexToEntRef(iEnt);
	}
	else tut[iClient] = INVALID_ENT_REFERENCE;
}

public bool OnDisplayItem(int iClient, const char[] sFeatureName, char[] sDisplay, int maxlen)
{
	FormatEx(sDisplay, maxlen, "Инвиз на радаре [%s]", VIP_IsClientFeatureUse(iClient, VIP_RADAR_INVIS) ? "Включено":"Выключено");
	return true;
}

public Action Event_PlayerTeam(Event event, const char[] name, bool dontBroadcast)
{
	CreateTimer(0.1, Timer_PlayerTeam, event.GetInt("userid"));
}

public Action Timer_PlayerTeam(Handle timer, any id)
{
	int iClient = GetClientOfUserId(id);
	if(iClient && !IsPlayerAlive(iClient))
	{
		int iEnt = EntRefToEntIndex(tut[iClient]);
		if(iEnt != INVALID_ENT_REFERENCE) AcceptEntityInput(iEnt, "Kill");
		tut[iClient] = INVALID_ENT_REFERENCE;
	}
}

public Action Event_PlayerDeath(Event event, const char[] name, bool dontBroadcast)
{
	int iClient = GetClientOfUserId(event.GetInt("userid"));
	int iEnt = EntRefToEntIndex(tut[iClient]);
	if(iEnt != INVALID_ENT_REFERENCE) AcceptEntityInput(iEnt, "Kill");
	tut[iClient] = INVALID_ENT_REFERENCE;
}

public bool OnCollision(int entity, int collisiongroup, int contentsmask, bool originalResult) 
{
	if(collisiongroup == 13 || collisiongroup == 0) return false;
	return true;
}